var express = require("express")
  , HTTPResult = require("../util/http-result")
  , _ = require("underscore")
  ;

module.exports = function(couch,schema) {
    var util = require('./util')(couch,schema);
    var topics = require('./topics')(couch,schema);
    var exports = {};

    var app = exports.app = express();

    var getCategories = exports.getCategories = function(sub) {
        var url = '_design/questions/_view/'+(sub||'all');
        return couch.get(url,{query:{reduce:true,group:true,group_level:1}})
        .handle({
            '-1': _.identity,
            200: function(result) {
                return _.map(result.rows, function(item) {
                    return { name:item.key[0], count:item.value };
                });
            },
            default: util.handleUnknownResponse
        });
    };

    app.get('/',
        util.ensureMIME(util.JSON_MIME),
        function(req,res) {
            var sub = 'published' in req.query && 'published';
            getCategories(sub)
            .handle({'-1': util.handleException})
            .handle(res.send.bind(res));
        });
    app.get('/:category/topics',
        util.ensureMIME(util.JSON_MIME),
        function(req,res) {
            var category = req.params.category;
            var sub = 'published' in req.query && 'published';
            topics.getTopicsWithCategory(category,sub)
            .handle({'-1': util.handleException})
            .handle(res.send.bind(res));
        });
    return exports;
};
